(function (window) {
  function arenaLogin() {
    var emailInput = document.querySelector('.albfre-settings--email')
    var passwordInput = document.querySelector('.albfre-settings--password')

    var email = sanitize(emailInput.value)
    var password = sanitize(passwordInput.value)

    if (!validateEmail(email)) {
      pageBodyLogin.style.display = 'block'
      pageLoading.style.display = 'none'
      emailInput.style.border = '1px dotted #cc5965'

      var errorLabel = document.querySelector('.albfre-form--error')
      errorLabel.style.display = 'block'
      return
    }

    var settings = {
      async: true,
      crossDomain: true,
      url: albfre_settings_object.albfre_api_signin_url,
      method: 'POST',
      headers: {
        'content-type': 'application/json'
      },
      processData: false,
      "data": "{\n    \"email\": \""+email+"\",\n    \"password\": \""+password+"\"\n}"
    }

    var pageBodyLogin = document.querySelector('.albfre-settings--body--login')
    var pageLoading = document.querySelector('.albfre-settings--body--sp')

    pageBodyLogin.style.display = 'none'
    pageLoading.style.display = 'block'

    jQuery.ajax(settings).done(function (response) {
      var data = {
        'action': 'albfre_user_action',
        'albfre_user': response
      };

      jQuery.post(albfre_settings_object.ajax_url, data, function(response) {
        window.location.reload();
      })
    }).fail(function() {
      pageBodyLogin.style.display = 'block'
      pageLoading.style.display = 'none'
      emailInput.style.border = '1px dotted #cc5965'
      passwordInput.style.border = '1px dotted #cc5965'

      var errorLabel = document.querySelector('.albfre-form--error')
      errorLabel.style.display = 'block'
    })
  }

  function arenaLogout () {
    var data = {
      'action': 'albfre_logout_action'
    };

    var pageBody = document.querySelector('.albfre-settings--body')
    pageBody.innerHTML = ''

    jQuery(pageBody).append('<div class="albfre-sp albfre-sp-circle"></div>')

    jQuery.post(albfre_settings_object.ajax_url, data, function(response) {
      window.location.reload();
    });
  }

  function arenaHandleKeydown (event) {
    event = event || window.event
    switch (event.which || event.keyCode) {
      // ENTER
      case 13: {
        arenaLogin()
        break
      }
    }
  }

  function validateEmail(email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
  }

  function sanitize(input) {
		var output = input.replace(/<script[^>]*?>.*?<\/script>/gi, '').
          replace(/<[\/\!]*?[^<>]*?>/gi, '').
          replace(/<style[^>]*?>.*?<\/style>/gi, '').
          replace(/<![\s\S]*?--[ \t\n\r]*>/gi, '');
    return output;
	}

  window.albfreWPPluginPreferences = {
    arenaLogin: arenaLogin,
    arenaLogout: arenaLogout,
    arenaHandleKeydown: arenaHandleKeydown
  }
})(window)

